${eCAP_AV_SDK_BOILERPLATE}

#ifndef ${eCAP_AV_SDK_GUARD}_ANSWERS_H
#define ${eCAP_AV_SDK_GUARD}_ANSWERS_H

#include "Async.h"
#include <list>

namespace Adapter {

class Service;
class Answer;

// a thread-safe queue of Antivirus Answers
class Answers
{
public:
    Answers();
    ~Answers();

    /* reference counting */
    void use();
    int abandon(); // may delete this
    int users() const; // some users may not put() their Answers yet

    // the result is ephemeral because another thread may add or remove answers
    bool empty() const;

    void put(Answer *answer);
    Answer *get();

private:
    mutable pthread_mutex_t lock; // protects all data members

    typedef std::list<Answer *> Queue;
    Queue queue; // answers ready to be delivered to the host

    int references; // number of objects pointing to us
};

} // namespace Adapter

#endif
